/*
 * MPEG audio file time indexing routines header
 *
 * Copyright (C) 2001 Adam Bernstein
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307  USA.
 */

/*
 * SccsId[] = "$Id: mpegindx.h,v 1.4.4.9 2003/08/16 20:28:13 number6 Exp $"
 */

#ifndef _MPEGINDX_H
#define _MPEGINDX_H

#include <stdio.h>


int mp3edit_skip_xing_header(FILE *fp);
int mp3edit_create_indexfile(void *ifctx);
int mp3edit_isvalid_index(FILE *mpegfp, FILE *indxfp);

long mp3edit_indexfile_sec(void *ifctx);
long mp3edit_indexfile_msec(void *ifctx);
long mp3edit_indexfile_frames(void *ifctx);
long mp3edit_indexfile_offset(void *ifctx);

FILE *init_timeindex_file(FILE *fp,
                          char *mpeg_filename,
                          char **rindx_filename);

_DSOEXPORT long _CDECL mp3edit_get_size_from_index(FILE *indxfp, 
                                                   long *sec, long *usec);
_DSOEXPORT char *_CDECL build_index_filename(char *path);
_DSOEXPORT char *_CDECL parse_pathname(const char *path,
                                       char **ret_filebase, char **ret_ext);

_DSOEXPORT int _CDECL validate_outfile(char *filename,
                                       int append, char **errstr);

#endif
